/*
tee file1 file2 ...

copies standard input to standard output and file1, file2, ...
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <error.h>
#include <ios1.h>
#include <proto/dos.h>

#define STR(x) # x

#define TRUE 1
#define FALSE 0

#define WARN 10
#define ERROR 20

#define MAXLEN 256 /* Max line length */
#define MAXF 10

extern int _bufsiz;
int err;

void main(int argc, char **argv)
{
    FILE *files[MAXF];
    int i, f, nb;
    char line[MAXLEN + 1], *mode;

    /* Setup stdout */
    if (IsInteractive(chkufb(fileno(stdout))->ufbfh))
        setvbuf(stdout, NULL, _IOLBF, _bufsiz);

    if (argc >= 2 && strcmp(argv[1], "-a") == 0)
    {
        argc--;
        argv++;
        mode = "a";
    }
    else
        mode = "w";

    if (argc > MAXF)
    {
        fputs("No more than " STR(MAXF) " files\n", stderr);
        nb = MAXF;
    }
    else
        nb = argc;

    for (i = 1, f = 0; i < nb; i++)
    {
        files[f] = fopen(argv[i], mode);

        if (!files[f])
        {
            char buf[81];

            buf[80] = '\0';
            strcpy(buf, "Error opening ");
            strncat(buf, argv[i], 80 - strlen(buf));
            perror(buf);
            fflush(stderr);
            err = WARN;
        }
        else
            f++;
    }

    line[MAXLEN] = '\0';
    while (fgets(line, MAXLEN, stdin) && err < ERROR)
    {
        fputs(line, stdout);
        for (i = 0; i < f && err < ERROR; i++)
        {
            fputs(line, files[i]);
            if (errno != 0) err = ERROR;
        }
    }
    fflush(stdout);

    for (i = 0; i < f && err < ERROR; i++)
    {
        fclose(files[i]);
        if (errno != 0) err = ERROR;
    }
    if (err >= ERROR) perror("tee failed");
    /* Any files left open will be closed */
    exit(err);
}

